// components/AddPic/add.js
const {
  api_upload_file,
} = require('../../utils/api.js');
const net = require('../../utils/net.js');
const util = require('../../utils/util.js');
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    field: {
      type: String,
      value: ''
    },
    contentType: {
      type: String,
      value: 'house'
    },
    count: {
      type: Number,
      value: 9
    },
    chooseLen: {
      type: Number,
      value: 0
    }
  },

  /**
   * 组件的初始数据
   */
  data: {

  },

  /**
   * 组件的方法列表
   */
  methods: {
    addPicHandle() {
      let {
        count,
        chooseLen
      } = this.data
      wx.chooseImage({
        count: count - chooseLen,
        sizeType: ['compressed'], // 可以指定是原图还是压缩图，默认二者都有
        sourceType: ['album', 'camera'],
        success: (res) => {
          let tempFilePaths = res.tempFilePaths;
          let tmpArr = []
          tempFilePaths.forEach((val) => {
            tmpArr.push({
              localPath: val,
              status: 1
            })
          });
          let {
            field
          } = this.data

          this.triggerEvent('addPicEvent', {
            tmpArr,
            field
          })

          tmpArr.forEach((val, index) => {
            this.uploadImg(val, index)
          })
        },
      })

    },
    uploadImg(val, index) {
      let formData = {
        // 'project': 'hooli',
        // 'contentType': this.data.contentType,
        'project': 'hooli',
        'contentType': 'oms/certificates',
      }
      Object.assign(formData, net.commonParams());
      formData.signToken = net.paramsSign(formData, api_upload_file);
      wx.uploadFile({
        url: api_upload_file,
        filePath: val.localPath,
        name: 'files[]',
        formData: formData,
        success: (res) => {
          let {
            statusCode,
            data,
            errMsg
          } = res;
          if (200 === statusCode) {
            data = JSON.parse(data);
            if (data) {
              let {
                code,
                msg
              } = data;
              if (0 === code) {
                val.status = 2

              } else {
                val.status = 3
              }
              this.triggerEvent('picStatus', {
                val,
                data: data.data,

              })
            }
          }
        }
      })
    }
  }
})