const {
  api_user_distributor,
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const {
  deepClone
} = require('../../utils/util.js');
Page({

  /**
   * 页面的初始数据
   */
  data: {
    totalList: [],
    traderList: [],
    activeIndex: null,
    value: null,
    noDataFlage: false,
    type: null
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      type: options.type
    }, () => {
      let { type } = this.data
      if (type === "trade") {
        const list = wx.getStorageSync('traderList')
        this.setData({
          traderList: list,
          totalList: list,
        })
      } else if (type === "adviser") {
        const list = wx.getStorageSync('adviserList')
        this.setData({
          traderList: list,
          totalList: list,
        })
      }
    })
  },
  getItemTrade(e) {
    let {
      item
    } = e.currentTarget.dataset
    let {
      id
    } = item
    this.setData({
      activeIndex: id
    })
    let pages = getCurrentPages();
    let prevPage = pages[pages.length - 2];
    if (prevPage && prevPage.searchListCallack) {
      prevPage.searchListCallack(item, this.data.type);
      wx.navigateBack();
    }
  },
  // 完成搜索
  search(event) {
    this.setData({
      value: event.detail.value
    }, () => {
      this.queryHandle(this.data.value)
    })
  },
  queryHandle(keyWord) {
    let arr = [];
    let reg = new RegExp(keyWord);
    let temArr = deepClone(this.data.totalList)
    temArr.forEach(val => {
      if (val.userName.match(reg)) {
        arr.push(val)
      }
    })
    this.setData({
      traderList: arr
    }, () => {
      if (this.data.traderList.length == 0) {
        this.setData({
          noDataFlage: true
        })
      } else {
        this.setData({
          noDataFlage: false
        })
      }
    })
  },
  // 实时搜索
  touchSearch(event) {
    let _this = this;
    clearTimeout(this.timer)
    this.timer = setTimeout(() => {
      _this.search(event);
    }, 500)
  },
})