const {
  api_user_verification,
  api_mobile_login
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');

Page({
  data: {
    btnDisabled: false,
    mobile: '',
    prefix: '',
    number: 60,
    code: '',
    btnCodeTips: '获取验证码'
  },
  onLoad: function(options) {
    let {
      mobile,
      prefix
    } = options
    this.setData({
      mobile: mobile,
      prefix: prefix
    }, () => {
      this.getCodeHandle()
    })
  },
  onReady: function() {
    wx.setNavigationBarTitle({
      title: '登录'
    });
  },
  regHandle() {
    let {
      mobile,
      prefix,
      code
    } = this.data
    if (!util.validator.checkCode(code)) {
      wx.showToast({
        title: '请输入正确的短信验证码',
        icon: 'none'
      })
      return false;
    }
    let params = {};
    params.data = {
      mobile: mobile,
      prefix: prefix,
      code: code
    }
    params.url = api_mobile_login;
    net.req(params, true).then((res) => {
      this.setData({
        btnDisabled: false
      });
      if (res) {
        let userInfo = res.data;
        wx.setStorageSync('userInfo', userInfo);
        wx.reLaunch({
          url: '/pages/home/home'
        });
      }
    }, (e) => {
      this.setData({
        btnDisabled: false
      });
      wx.showModal({
        title: '提示',
        content: (e && e.msg) || '抱歉，您暂无登录权限，合作请咨询400-898-6659',
        showCancel: false
      });
    });
    this.setData({
      btnDisabled: true
    });
  },
  bindCodeHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      code: value
    })
  },
  getCodeHandle() {
    let params = {};
    let {
      mobile,
      prefix
    } = this.data
    params.data = {
      mobile: mobile,
      status: 8,
      countryId: prefix
    }
    params.url = api_user_verification;
    net.req(params, true).then((res) => {
      wx.showToast({
        title: '发送短信验证码成功',
        icon: 'none'
      })
      this.time()
    }, (e) => {
      wx.showToast({
        title: (e && e.msg) || '发送短信验证码失败',
        icon: 'none'
      })
    });
  },
  time() {
    let num = 60;
    let timer = setInterval(() => {
      num--;
      this.setData({
        number: num
      }, () => {
        if (num === 0) {
          clearInterval(timer);
          this.setData({
            number: 60,
            btnCodeTips: '重新获取'
          })
        }
      })
    }, 1000);
  }
})