const {
  api_crm_intention,
  api_country_prefix,
  api_linkage_cities,
  api_crm_degree_list
} = require('../../utils/api')
const {
  net
} = require('../../utils/net.js')
const {
  formatMonth
} = require('../../utils/time.js')
const { validator } = require('../../utils/util.js');
Page({
  data: {
    sex: 0,
    index: 0,
    multiIndex: [0, 0, 0],
    prefixArray: [],
    cityIndex: 11,
    cityArray: [],
    isShowCity: true,
    currMonth: formatMonth(new Date),
    cityId: 0,
    provinceId: 0,
    describe: '',
    liveTime: 0,
    prefixMobile: '',
    countryArray: [],
    countryId: '',
    provinceArray: [],
    provinceId: '',
    cities: '',
    cityId: '',
    nickName: '',
    showDegreeDefault: true,
    degreeList: [],
    degreeIndex: -1,
    btnDisabled: false
  },
  pageData: {

  },
  bindPickerChange(e) {
    this.setData({
      cityIndex: e.detail.value
    })
    this.data.prefixArray.forEach((val, index) => {
      if (e.detail.value == index) {
        this.setData({
          prefixMobile: val.id
        })
      }
    });
  },
  bindNickName(e) {
    this.setData({
      nickName: e.detail.value
    })
  },
  onLoad: function (options) {
    const { scene } = options;
    if (options && scene) {
      this.setData({
        shareToken: scene
      })
    } else if (options && options.shareToken) {
      this.setData({
        shareToken: options.shareToken
      })
    }
    this.prefix()
    this.country()
    this.getDegreeList()
  },
  tapSexAction(e) {
    const { sexIndex } = e.currentTarget.dataset;
    this.setData({
      sex: parseInt(sexIndex)
    })
  },
  getDegreeList() {
    let params = {
      url: api_crm_degree_list
    }
    net.req(params).then((res) => {
      this.setData({
        degreeList: res.data
      })
    })
  },
  prefix() {
    let params = {
      url: api_country_prefix
    }
    net.req(params).then((res) => {
      res.data.forEach((ele, index) => {
        ele.label = `（${ele.prefix}）${ele.name}`
        if (["86", "086", "+86", "+086"].indexOf(ele.prefix) !== -1) {
          this.setData({
            cityIndex: index,
            prefixMobile: res.data[index].id
          })
        }
      });
      this.setData({
        prefixArray: res.data,
      })
    })
  },
  country() {
    let params = {
      url: api_linkage_cities
    }
    params.data = {}
    net.req(params).then((res) => {
      this.setData({
        'cityArray[0]': res.data,
        countryArray: res.data,
        countryId: res.data[0].id
      }, () => {
        this.province(res.data[0].id)
      })
    })
  },
  province(id) {
    let params = {
      url: api_linkage_cities
    }
    params.data = {}
    params.data.pid = id
    net.req(params).then((res) => {
      if (res.data) {
        this.setData({
          'cityArray[1]': res.data,
          provinceArray: res.data,
          provinceId: res.data[0].id
        }, () => {
          this.city(res.data[0].id)
        })
      } else {
        this.setData({
          'cityArray[1]': [],
          'cityArray[2]': [],
          provinceId: 0
        })

      }
    })
  },
  city(id) {
    let params = {
      url: api_linkage_cities
    }
    params.data = {}
    params.data.pid = id
    net.req(params).then((res) => {
      if (res.data && res.data.length) {
        this.setData({
          'cityArray[2]': res.data,
          cities: res.data,
          cityId: res.data[0].id
        })
      } else {
        this.setData({
          'cityArray[2]': [],
          cityId: 0
        })
      }
    })
  },
  bindMultiPickerChange(e) {
    this.setData({
      multiIndex: e.detail.value,
      isShowCity: false
    });
  },
  bindDateChange(e) {
    this.setData({
      date: e.detail.value,
      liveTime: (new Date(e.detail.value)).getTime()
    })
  },
  bindMultiPickerColumnChange(e) {
    if (e.detail.column == 0) {
      this.data.countryArray.forEach((val, index) => {
        if (index == e.detail.value) {
          this.setData({
            countryId: val.id,
            isShowCity: false
          })
          this.province(val.id)
        }
      })
    } else if (e.detail.column == 1) {
      this.data.provinceArray.forEach((val, index) => {
        if (index == e.detail.value) {
          this.setData({
            provinceId: val.id
          })
          this.city(val.id)
        }
      })
    } else {
      this.data.cities.forEach((val, index) => {
        if (index == e.detail.value) {
          this.setData({
            cityId: val.id
          })
        }
      })
    }
    const data = {
      multiArray: this.data.cityArray,
      multiIndex: this.data.multiIndex
    }
    data.multiIndex[e.detail.column] = e.detail.value
    switch (e.detail.column) {
      case 0:
        data.multiArray[1] = this.data.provinceArray
        data.multiIndex[1] = 0
        break
      case 1:
        switch (data.multiIndex[1]) {
          case 0:
            data.multiArray[1] = this.data.cities
            break
        }
        data.multiIndex[2] = 0
        break
    }
    this.setData(data)
  },
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '意向收集'
    })
  },
  describeFuc(e) {
    this.setData({
      describe: e.detail.value
    })
  },
  radioChange(e) {
    this.setData({
      sex: e.detail.value
    })
  },
  checkUserNickname: (s) => { /*校验昵称格式是否正确*/
    if (s) {
      s = s.replace(/\s/g, "");
      var rule = /^[A-Za-z0-9\u4e00-\u9fa5]{2,20}$/;
      return rule.test(s);
    }
    return false;
  },
  formSubmit(e) {
    if (!this.checkUserNickname(this.data.nickName)) {
      wx.showToast({
        title: '姓名或昵称（2~20位，由字母或数字或汉字组成）',
        icon: 'none',
        duration: 2000
      });
      return false;
    }
    if (!this.data.sex) {
      wx.showToast({
        title: '请选择性别',
        icon: 'none',
        duration: 2000
      });
      return false;
    }
    if (!e.detail.value.mobile) {
      wx.showToast({
        title: '请您输入正确手机号',
        icon: 'none',
        duration: 2000
      });
      return false
    }
    if (!e.detail.value.wechat) {
      wx.showToast({
        title: '请您输入正确微信',
        icon: 'none',
        duration: 2000
      });
      return false
    }
    if (this.data.isShowCity) {
      wx.showToast({
        title: '请选择意向城市',
        icon: 'none',
        duration: 2000
      });
      return false;
    }
    if (!this.data.liveTime) {
      wx.showToast({
        title: '请选择入住时间',
        icon: 'none',
        duration: 2000
      });
      return false;
    }
    let params = {}
    params.url = api_crm_intention
    params.data = {
      sex: this.data.sex,
      prefixMobile: this.data.prefixMobile,
      cityId: this.data.cityId,
      provinceId: this.data.provinceId,
      countryId: this.data.countryId,
      liveTime: this.data.liveTime ? this.data.liveTime / 1000 : '',
      shareToken: this.data.shareToken,
      describe: this.data.describe,
      degree: this.data.degreeIndex == -1 ? 0 : this.data.degreeList[this.data.degreeIndex].val
    }
    Object.assign(params.data, e.detail.value)

    this.setData({
      btnDisabled: true
    });

    net.req(params,true).then((res) => {
      wx.navigateTo({
        url: '/pages/collectionSucceed/collectionSucceed',
      })
    },(e)=>{
      wx.showToast({
        title: e.msg || 'error',
        icon: 'none',
        duration: 2000
      });
      this.setData({
        btnDisabled: false
      });
    })
  },
  degreeChange(e) {
    this.setData({
      showDegreeDefault: false,
      degreeIndex: e.detail.value
    })
  },
})