const {
  api_crm_detail
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');

Page({
  data: {
    stateFlage:false,
    current: 0,
    tabs: ['详细信息', '跟进信息','关联订单'],
    id: '',
    data: {}
  },
  pageData: {

  },
  onLoad: function (options) {
    this.setData({
      id: options.id
    }, () =>{
      this.getData();
    })
  },
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '线索详情'
    })
  },
  onShow: function () {

  },
  onHide: function () {

  },
  // 滑动切换
  swiperChange(options){
    this.setData({
      current: options.detail.current
    })
  },
  // 点击切换
  slideTab(options){
    this.setData({
      current: options.currentTarget.dataset.index
    })
  },
  // 获取数据
  getData() {
    wx.showLoading({
      icon:'none'
    })
    let _this = this
    let params = {
      url: api_crm_detail,
      data: {
        id: this.data.id
      }
    }
    net.req(params).then((res) => {
      wx.hideLoading()
      _this.setData({
        data: res.data,
        stateFlage:true
      })
    })
  },
  copyWXAction(e) {
    const {currentWx} = e.currentTarget.dataset;
    if (currentWx && currentWx.length) {
      wx.setClipboardData({
        data: currentWx,
        success(res) {
        }
      })
    }
  },

  copyQQAction(e) {
    const {currentQq} = e.currentTarget.dataset;
    if (currentQq && currentQq.length) {
      wx.setClipboardData({
        data: currentQq,
        success(res) {
        }
      })
    }
  },

  tapTelAction(e) {
    const {tel} = e.currentTarget.dataset;
    let _this = this;
    let systemInfo = util.getStorageSync('systemInfo');
    if (!systemInfo) {
      systemInfo = wx.getSystemInfoSync();
      if (systemInfo) {
        wx.setStorageSync('systemInfo', systemInfo);
      }
    }
    let { system } = systemInfo;
    if (system.toLowerCase().indexOf('ios') !== -1) {
      wx.makePhoneCall({
        phoneNumber: tel
      });
    } else {
      wx.showActionSheet({
        itemList: [tel],
        success(res) {
          if (res.tapIndex === 0) {
            wx.makePhoneCall({
              phoneNumber: _this.data.phone
            });
          }
        }
      })
    }
  },
  copyNumAction(e) {
    const {currentNum} = e.currentTarget.dataset;
    if (currentNum && currentNum.length) {
      wx.setClipboardData({
        data: currentNum,
        success(res) {
        }
      })
    }
  }
})