const {
  api_crm_clue_list
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');

Page({
  data: {
    uid:null,
    data: [],
    value: '',
    isLoad: false,
    noMoreData: false
  },
  pageData: {
    page: 1,
    limit: 10
  },
  onLoad: function (options) {
    if (options && options.uid) {
      this.setData({
        uid: options.uid
      });
    }
  },
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '线索搜索'
    })
    wx.setBackgroundColor({
      backgroundColorBottom: '#fafafa'
    });
  },
  onShow: function () {

  },
  onHide: function () {

  },
  // 完成搜索
  search(event) {
    this.setData({
      noMoreData: false,
      value: event.detail.value
    }, () => {
      this.getData(1);
    })
  },
  // 实时搜索
  touchSearch(event) {
    let _this = this;
    clearTimeout(this.timer)
    this.timer = setTimeout(() => {
      _this.search(event);
    }, 500)
  },
  // 获取数据
  getData(page) {
    if (this.data.noMoreData) {
      return;
    }
    let _this = this
    let params = {
      url: api_crm_clue_list,
      data: {
        page: page,
        limit: _this.pageData.limit,
        keywords: _this.data.value
      }
    }

    if (this.data.uid) {
      params.data.uid = this.data.uid
    }
    console.log(params)
    net.req(params).then((res) => {
      _this.setData({
        isLoad: true
      })
      if (res.data.list.length == 0) {
        _this.setData({
          noMoreData: true
        })
      }
      if (page == 1) {
        _this.setData({
          data: res.data.list
        })
      } else {
        _this.setData({
          data: _this.data.data.concat(res.data.list)
        })
      }
    })
  },
  // 加载更多
  onReachBottom: function () {
    let page = this.pageData.page + 1
    this.pageData.page = page
    this.getData(page)
  },
  // 详情页
  showDetail(options) {
    wx.navigateTo({
      url: `/pages/leadsdetail/leadsdetail?id=${options.currentTarget.dataset.id}`
    })
  },
  copyWXAction(e) {
    const {currentWx} = e.currentTarget.dataset;
    if (currentWx && currentWx.length) {
      wx.setClipboardData({
        data: currentWx,
        success(res) {
        }
      })
    }
  },

  tapTelAction(e) {
    const {tel} = e.currentTarget.dataset;
    let _this = this;
    let systemInfo = util.getStorageSync('systemInfo');
    if (!systemInfo) {
      systemInfo = wx.getSystemInfoSync();
      if (systemInfo) {
        wx.setStorageSync('systemInfo', systemInfo);
      }
    }
    let { system } = systemInfo;
    if (system.toLowerCase().indexOf('ios') !== -1) {
      wx.makePhoneCall({
        phoneNumber: tel
      });
    } else {
      wx.showActionSheet({
        itemList: [tel],
        success(res) {
          if (res.tapIndex === 0) {
            wx.makePhoneCall({
              phoneNumber: _this.data.phone
            });
          }
        }
      })
    }
  }
})