const { api_wx_login } = require('../../utils/api.js');
const { net } = require('../../utils/net.js');
const util = require('../../utils/util.js');

Page({
  data: {
    showState: '1',
    tel: '400-898-6659'
  },
  pageData: {
    wxCode: ''
  },
  onLoad(options) {
    let confTel = util.getStorageSync('conf');
    if (confTel && confTel.telCn) {
      this.setData({
        tel: confTel.telCn
      })
    }
    let userInfo = util.getStorageSync('userInfo');
    if (userInfo && userInfo.token) {
      wx.reLaunch({
        url: '/pages/home/home',
      });
    } else {
      this.setData({
        showState: '2'
      });
      wx.login({
        success: (res) => {
          this.pageData.wxCode = res.code;
        }
      });
    }
  },
  onReady() {
    wx.setNavigationBarTitle({
      title: '登录'
    });
  },
  getPhoneNumber(e) {
    let { encryptedData, iv } = e.detail;
    if (!encryptedData || !iv) {
      return false;
    }
    let goNext = () => {
      console.log(666);
      wx.login({
        success: (res) => {
          let {
            code
          } = res;
          if (!code) {
            return false;
          }
          this.wxLogin(code, encryptedData, iv)
        }
      })
    };
    wx.checkSession({
      success: () => {
        if (this.pageData.wxCode) {
          this.wxLogin(this.pageData.wxCode, encryptedData, iv);
        } else {
          goNext();
        }
      },
      fail: () => {
        goNext();
      }
    });
  },
  wxLogin(code, encryptedData, iv) {
    let params = {};
    params.url = api_wx_login;
    params.data = {
      code,
      encryptedData,
      iv
    };
    net.req(params, true).then((res) => {
      let { data } = res;
      if (data && data.token) {
        wx.setStorageSync('userInfo', data);
        wx.reLaunch({
          url: '/pages/home/home',
        });
        return false;
      }
      wx.showModal({
        title: '提示',
        content: `抱歉，您暂无登录权限，合作请咨询${this.data.tel}`,
        showCancel: false
      });
    }, (e) => {
      wx.showModal({
        title: '提示',
        content: (e && e.msg) || `抱歉，您暂无登录权限，合作请咨询${this.data.tel}`,
        showCancel: false
      });
    });
  },
  handleMobileLogin() {
    wx.navigateTo({
      url: '/pages/loginmobile/loginmobile',
    })
  },
  handleMakePhone() {
    let { tel } = this.data;
    let systemInfo = util.getStorageSync('systemInfo');
    if (!systemInfo) {
      systemInfo = wx.getSystemInfoSync();
      if (systemInfo) {
        wx.setStorageSync('systemInfo', systemInfo);
      }
    }
    let {
      system
    } = systemInfo;
    if (system.toLowerCase().indexOf('ios') !== -1) {
      wx.makePhoneCall({
        phoneNumber: tel
      });
    } else {
      wx.showActionSheet({
        itemList: [tel],
        success(res) {
          if (res.tapIndex === 0) {
            wx.makePhoneCall({
              phoneNumber: tel
            });
          }
        }
      });
    }
  }
})