const {
  api_user_my_user
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');

Page({

  /**
   * 页面的初始数据
   */
  data: {
    data: [],
    id: '',
    isLoad: false,
    noMoreData: false
  },
  pageData: {
    page: 1,
    limit: 10
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (options.id) {
      this.setData({
        id: options.id
      }, () => {
        this.getData('1')
      })
    }else{
      this.getData('1')
    }
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '分销顾问',
    });
    wx.setBackgroundColor({
      backgroundColorBottom: '#fafafa'
    });
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    let page = this.pageData.page + 1
    this.pageData.page = page
    this.getData(page)
  },
  // 查看线索列表
  toLeadsList(options) {
    wx.navigateTo({
      url: `/pages/myleadslist/myleadslist?id=${options.currentTarget.dataset.id}`
    })
  },
  // 获取数据
  getData(page) {
    if (this.data.noMoreData) {
      return;
    }
    let _this = this
    let params = {
      url: api_user_my_user,
      data: {
        page: page,
        limit: this.pageData.limit
      }
    }
    if (this.data.id) {
      params.data.pid = this.data.id
    }
    net.req(params).then((res) => {
      _this.setData({
        isLoad: true
      })
      if (res.data.list.length == 0) {
        _this.setData({
          noMoreData: true
        })
      } else {
        if (page == 1) {
          _this.setData({
            data: res.data.list
          })
        } else {
          _this.setData({
            data: _this.data.data.concat(res.data.list)
          })
        }
      }
    })
  }
})