const {
  api_user_my_user
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');

Page({

  /**
   * 页面的初始数据
   */
  data: {
    current: 0,
    tabs: ['企业', '个人'],
    id: '',
    height: '',
    isLoad: false,
    noMoreData: false,
    value: "",
    data: {}
  },
  pageData: {
    page: 1,
    limit: 10
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.getData('1', this.data.current)
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '分销商',
    });
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    let page = this.pageData.page + 1
    this.pageData.page = page
    this.getData(page, this.data.current)
  },

  // 点击切换
  slideTab(options) {
    const current = options.currentTarget.dataset.index;
    this.setData({
      current: current,
      noMoreData: false,
      value: ""
    }, () => {
      this.pageScrollToTop();
      this.getData('1', this.data.current);
    });


  },

  pageScrollToTop() {
    if (wx.pageScrollTo) {
      wx.pageScrollTo({
        scrollTop: 0,
        duration: 0
      })
    }
  },
  // 查看线索列表
  toLeadsList(options) {
    wx.navigateTo({
      url: `/pages/myleadslist/myleadslist?id=${options.currentTarget.dataset.id}`
    })
  },

  // 完成搜索
  search(event) {
    this.setData({
      noMoreData: false,
      value: event.detail.value
    }, () => {
      this.pageScrollToTop();
      this.getData('1', this.data.current)
    })
  },
  // 实时搜索
  touchSearch(event) {
    let _this = this;
    clearTimeout(this.timer)
    this.timer = setTimeout(() => {
      _this.search(event);
    }, 500)
  },

  // 获取数据
  getData(page, type) {
    if (this.data.noMoreData) {
      return;
    }
    let _this = this
    let params = {
      url: api_user_my_user,
      data: {
        keywords: _this.data.value,
        page: page,
        limit: _this.pageData.limit
      }
    }
    type == 0 ? params.data.userType = 2 : params.data.userType = 3
    net.req(params).then((res) => {
      _this.setData({
        isLoad: true
      })
      if (res.data.list.length == 0) {
        _this.setData({
          noMoreData: true
        });
        if (page == 1) {
          _this.setData({
            data: []
          })
        }
      } else {
        if (page == 1) {
          _this.setData({
            data: res.data.list
          })
        } else {
          _this.setData({
            data: _this.data.data.concat(res.data.list)
          })
        }
      }
    })
  }
})