const {
  api_crm_clue_list
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');

Page({
  data: {
    data: [],
    id: '',
    isLoad: false,
    noMoreData: false
  },
  pageData: {
    page: 1,
    limit: 10
  },
  onLoad: function (options) {
    this.setData({
      id: options.id
    }, () => {
      this.getData('1');
    })
  },
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '线索列表'
    })
  },
  // 搜索
  toSearch() {
    wx.navigateTo({
      url: `/pages/leadssearch/leadssearch?uid=${this.data.id}`
    })
  },

  // 获取数据
  getData(page) {
    if (this.data.noMoreData) {
      return;
    }
    let _this = this
    let params = {
      url: api_crm_clue_list,
      data: {
        page: page,
        limit: _this.pageData.limit,
        uid: _this.data.id
      }
    }
    net.req(params).then((res) => {
      _this.setData({
        isLoad: true
      })
      if (res.data.list.length == 0) {
        _this.setData({
          noMoreData: true
        })
      } else {
        if (page == 1) {
          _this.setData({
            data: res.data.list
          })
        } else {
          _this.setData({
            data: _this.data.data.concat(res.data.list)
          })
        }
      }
    })
  },
  // 加载更多
  onReachBottom: function () {
    let page = this.pageData.page + 1
    this.pageData.page = page
    this.getData(page)
  },
  // 详情页
  showDetail(options) {
    const {currentIndex,id} = options.currentTarget.dataset;
    const obj = this.data.data[currentIndex];
    
    if (obj.isNew == 1) {
      obj.isNew = 0;
      this.data.data[currentIndex] = obj;
      this.setData({
        data:this.data.data
      });
    }
    
    wx.navigateTo({
      url: `/pages/leadsdetail/leadsdetail?id=${id}`
    })
  },
  copyWXAction(e) {
    const {currentWx} = e.currentTarget.dataset;
    if (currentWx && currentWx.length) {
      wx.setClipboardData({
        data: currentWx,
        success(res) {
        }
      })
    }
  },

  tapTelAction(e) {
    const {tel} = e.currentTarget.dataset;
    let _this = this;
    let systemInfo = util.getStorageSync('systemInfo');
    if (!systemInfo) {
      systemInfo = wx.getSystemInfoSync();
      if (systemInfo) {
        wx.setStorageSync('systemInfo', systemInfo);
      }
    }
    let { system } = systemInfo;
    if (system.toLowerCase().indexOf('ios') !== -1) {
      wx.makePhoneCall({
        phoneNumber: tel
      });
    } else {
      wx.showActionSheet({
        itemList: [tel],
        success(res) {
          if (res.tapIndex === 0) {
            wx.makePhoneCall({
              phoneNumber: _this.data.phone
            });
          }
        }
      })
    }
  }
})