const {
  api_country_prefix,
  api_user_register,
  api_user_verification
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');
Page({
  data: {
    btnDisabled: false,
    formData: {
      shareToken: '',
      userName: '',
      mobile: '',
      code: '',
      prefix: ''
    },
    indexMobile: 0,
    arrayMobile: [],
    number: 60,
    time: null,
    reCode: false
  },
  pageData: {

  },
  onLoad: function (options) {
    const { scene, shareToken } = options;
    if (scene) {
      this.setData({
        [`formData.shareToken`]: scene
      })
    } else if (shareToken) {
      this.setData({
        [`formData.shareToken`]: shareToken
      })
    }
    this.getMobileArrHandle()
  },
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '注册顾问'
    })
  },

  onHide: function () {
    if (_this.data.time) {
      clearInterval(_this.data.time);
      _this.data.time = null;
    }
  },
  bindUserNameHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.userName`]: value
    });
    this.checkWithParams();
  },
  bindTelHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.mobile`]: value
    });
    this.checkWithParams();
  },
  bindPickerChange(e) {
    this.setData({
      indexMobile: e.detail.value
    });
  },
  bindCodeHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.code`]: value
    });
    this.checkWithParams();
  },

  checkWithParams() {
    const {
      userName,
      mobile,
      code
    } = this.data.formData;
    if (userName.length > 0 && mobile.length > 0 && code.length > 0) {
      this.setData({
        btnDisabled: true
      });
    }
  },

  getMobileArrHandle() {
    let params = {};
    params.url = api_country_prefix;
    net.req(params, true).then((res) => {
      let {
        data
      } = res
      data.forEach((ele, index) => {
        ele.customize = `（${ele.prefix}）${ele.name}`
        if (["86", "086", "+86", "+086"].indexOf(ele.prefix) !== -1) {
          this.setData({
            indexMobile: index
          })
        }
      })
      this.setData({
        arrayMobile: data
      }, () => {})
    }, (e) => {
      wx.showToast({
        title: e.msg,
        icon: 'none'
      })
    });
  },
  regHandle() {

    if (!this.data.formData.userName) {
      wx.showToast({
        title: '姓名不能为空',
        icon: 'none'
      })
      return false
    }
    if (!this.data.formData.mobile) {
      wx.showToast({
        title: '手机号不能为空',
        icon: 'none'
      })
      return false
    }
    if (!this.data.formData.code) {
      wx.showToast({
        title: '验证码不能为空',
        icon: 'none'
      })
      return false
    }
    this.setData({
      [`formData.prefix`]: this.data.arrayMobile[this.data.indexMobile].id
    })
    this.submitData()
  },
  getCodeHandle() {
    if (!this.data.formData.mobile) {
      wx.showToast({
        title: '手机号不能为空',
        icon: 'none'
      })
      return false
    }

    let params = {};

    params.data = {
      mobile: this.data.formData.mobile,
      status: 8,
      countryId: this.data.arrayMobile[this.data.indexMobile].id
    }
    params.url = api_user_verification;
    net.req(params, true).then((res) => {
      wx.showToast({
        title: '发送验证码成功',
        icon: 'none'
      })
      this.time()
    }, (e) => {
      wx.showToast({
        title: e.msg,
        icon: 'none'
      })
    });
  },
  submitData() {
    let params = {};
    params.data = this.data.formData
    params.data.userType = 4
    params.url = api_user_register;
    net.req(params, true).then((res) => {
      wx.showToast({
        title: res.msg,
        icon: 'none'
      })
      wx.reLaunch({
        url: "/pages/registersuccess/registersuccess?type=4",
      })
    }, (e) => {
      wx.showToast({
        title: e.msg,
        icon: 'none'
      })
    });
  },
  time() {
    let num = 60;
    const _this = this;
    _this.data.time = setInterval(() => {
      num--;
      this.setData({
        number: num,
        reCode: true
      }, () => {
        if (num === 0) {
          clearInterval(_this.data.time);
          this.setData({
            number: 60
          })
        }
      })
    }, 1000);
  },
})