const {
  api_country_prefix,
  api_user_register,
  api_user_verification
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');
Page({
  data: {
    btnDisabled: false,
    formData: {
      shareToken: '',
      userName: '',
      mobile: '',
      code: '',
      prefix: '',
      companyName: '',
      companyShortName: '',
      licenseCode: '',
    },
    indexMobile: 0,
    arrayMobile: [],
    number: 60,
    image: [],
    checkProtocol: false,
    reCode: false
  },
  pageData: {

  },
  onLoad: function (options) {
    let {
      shareToken
    } = options
    this.getMobileArrHandle()
    this.setData({
      [`formData.shareToken`]: shareToken
    })
  },
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '注册企业分销商'
    })
  },
  bindUserNameHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.userName`]: value
    })
  },
  bindTelHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.mobile`]: value
    })
  },
  bindPickerChange(e) {
    this.setData({
      indexMobile: e.detail.value
    })
  },
  bindCodeHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.code`]: value
    })
  },
  bindcompanyNameHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.companyName`]: value
    })
  },
  bindcompanyShortNameHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.companyShortName`]: value
    })
  },
  bindlicenseCodeHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.licenseCode`]: value
    })
  },
  getMobileArrHandle() {
    let params = {};
    params.url = api_country_prefix;
    net.req(params, true).then((res) => {
      let {
        data
      } = res
      data.forEach((ele, index) => {
        ele.customize = `（${ele.prefix}）${ele.name}`
        if (["86", "086", "+86", "+086"].indexOf(ele.prefix) !== -1) {
          this.setData({
            indexMobile: index
          })
        }
      })
      this.setData({
        arrayMobile: data
      }, () => { })
    }, (e) => {
      wx.showToast({
        title: e.msg,
        icon: 'none'
      })
    });
  },
  regHandle() {
    if (!this.data.formData.userName) {
      wx.showToast({
        title: '姓名不能为空',
        icon: 'none'
      })
      return false
    }
    if (!this.data.formData.mobile) {
      wx.showToast({
        title: '手机号不能为空',
        icon: 'none'
      })
      return false
    }
    if (!this.data.formData.code) {
      wx.showToast({
        title: '验证码不能为空',
        icon: 'none'
      })
      return false
    }
    if (!this.data.formData.companyName) {
      wx.showToast({
        title: '企业全称不能为空',
        icon: 'none'
      })
      return false
    }
    if (!this.data.checkProtocol) {
      wx.showToast({
        title: '请同意用户协议',
        icon: 'none'
      })
      return false
    }

    this.setData({
      [`formData.prefix`]: this.data.arrayMobile[this.data.indexMobile].id
    })
    this.submitData()
  },
  getCodeHandle() {
    if (!this.data.formData.mobile) {
      wx.showToast({
        title: '手机号不能为空',
        icon: 'none'
      })
      return false
    }

    let params = {};

    params.data = {
      mobile: this.data.formData.mobile,
      status: 8,
      countryId: this.data.arrayMobile[this.data.indexMobile].id
    }
    params.url = api_user_verification;
    net.req(params, true).then((res) => {
      wx.showToast({
        title: res.msg,
        icon: 'none'
      })
      this.time()
    }, (e) => {
      wx.showToast({
        title: e.msg,
        icon: 'none'
      })
    });
  },
  submitData() {
    this.setData({
      btnDisabled: true
    })

    let params = {};
    params.data = this.data.formData
    params.data.userType = 2
    if (this.data.image.length > 0) {
      let temArr = []
      this.data.image.forEach(val => {
        temArr = temArr.concat(val.data.url[0])
      })
      params.data.licensefile = JSON.stringify(temArr)
    } else {
      params.data.licensefile = ''
    }
    params.url = api_user_register;
    net.req(params, true).then((res) => {
      wx.showToast({
        title: res.msg,
        icon: 'none'
      })
      wx.reLaunch({
        url: "/pages/registersuccess/registersuccess?type=2",
      })
    }, (e) => {
      wx.showToast({
        title: e.msg,
        icon: 'none'
      })
    });
  },
  time() {
    let num = 60;
    let timer = setInterval(() => {
      num--;
      this.setData({
        number: num,
        reCode: true
      }, () => {
        if (num === 0) {
          clearInterval(timer);
          this.setData({
            number: 60
          })
        }
      })
    }, 1000);

  },

  //所有上传的图片
  addPicEventHandle(detail) {
    let tempArr = util.deepClone(this.data.image)
    tempArr = tempArr.concat(detail.detail.tmpArr)
    this.setData({
      image: tempArr
    })
  },
  //上传成功改变状态
  picStatusHandle(detail) {
    let content = detail.detail
    let {
      data,
      val
    } = content
    let tempLocalPath = util.deepClone(val.localPath)
    this.data.image.forEach((item, index) => {
      if (tempLocalPath === item.localPath) {
        this.setData({
          [`image[${index}].status`]: val.status,

        }, () => {
          if (data) {
            this.setData({
              [`image[${index}].data`]: data,
              [`image[${index}].localPath`]: data.host + data.url
            })
          }
        })
      }
    })

  },
  //删除文件
  closeEventHandle(detail) {
    wx.showModal({
      title: '确认删除',
      success: (res) => {
        if (res.confirm) {
          let {
            tag,
            imgSrc
          } = detail.detail
          this.data.image.forEach((item, index) => {
            if (item.localPath === imgSrc.localPath) {
              this.delImag(imgSrc.data ? imgSrc.data.url : '', index)
            }
          })
        }
      },
      fail: () => { }
    })
  },
  //删除文件接口
  delImag(url, index) {
    let temArr = util.deepClone(this.data.image)
    temArr.splice(index, 1)
    this.setData({
      image: temArr
    })
  },
  // 同意协议
  checkProtocol() {
    this.setData({
      checkProtocol: !this.data.checkProtocol
    })
  },
  // 查看协议
  toProtocol() {
    wx.navigateTo({
      url: `/pages/protocol/protocol`
    })
  }
})