const {
  api_country_prefix,
  api_user_register,
  api_user_verification
} = require('../../utils/api.js');
const {
  net
} = require('../../utils/net.js');
const util = require('../../utils/util.js');
Page({
  data: {
    btnDisabled: false,
    formData: {
      shareToken: '',
      userName: '',
      mobile: '',
      code: '',
      prefix: ''
    },
    indexMobile: 0,
    arrayMobile: [],
    number: 60,
    checkProtocol: false,
    reCode: false
  },
  pageData: {

  },
  onLoad: function (options) {
    let {
      shareToken
    } = options
    console.log(options)
    this.getMobileArrHandle()
    this.setData({
      [`formData.shareToken`]: shareToken
    })
  },
  onReady: function () {
    wx.setNavigationBarTitle({
      title: '注册个人分销商'
    })
  },
  onShow: function () {

  },
  onHide: function () {

  },
  bindUserNameHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.userName`]: value
    });
  },
  bindTelHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.mobile`]: value
    });
  },
  bindPickerChange(e) {
    this.setData({
      indexMobile: e.detail.value
    })
  },
  bindCodeHandle(e) {
    let {
      value
    } = e.detail
    this.setData({
      [`formData.code`]: value
    });
  },

  getMobileArrHandle() {
    let params = {};
    params.url = api_country_prefix;
    net.req(params, true).then((res) => {
      let {
        data
      } = res
      data.forEach((ele, index) => {
        ele.customize = `（${ele.prefix}）${ele.name}`
        if (["86", "086", "+86", "+086"].indexOf(ele.prefix) !== -1) {
          this.setData({
            indexMobile: index
          })
        }
      })
      this.setData({
        arrayMobile: data
      }, () => { })
    }, (e) => {
      wx.showToast({
        title: e.msg,
        icon: 'none'
      })
    });
  },
  regHandle() {
    if (!this.data.formData.userName) {
      wx.showToast({
        title: '姓名不能为空',
        icon: 'none'
      })
      return false
    }
    if (!this.data.formData.mobile) {
      wx.showToast({
        title: '手机号不能为空',
        icon: 'none'
      })
      return false
    }
    if (!this.data.formData.code) {
      wx.showToast({
        title: '验证码不能为空',
        icon: 'none'
      })
      return false
    }
    if (!this.data.checkProtocol) {
      wx.showToast({
        title: '请同意用户协议',
        icon: 'none'
      })
      return false
    }
    this.setData({
      [`formData.prefix`]: this.data.arrayMobile[this.data.indexMobile].id
    })
    this.submitData()
  },
  getCodeHandle() {
    if (!this.data.formData.mobile) {
      wx.showToast({
        title: '手机号不能为空',
        icon: 'none'
      })
      return false
    }

    let params = {};

    params.data = {
      mobile: this.data.formData.mobile,
      status: 8,
      countryId: this.data.arrayMobile[this.data.indexMobile].id
    }
    params.url = api_user_verification;
    net.req(params, true).then((res) => {
      wx.showToast({
        title: "发送验证码成功",
        icon: 'none'
      })
      this.time()
    }, (e) => {
      wx.showToast({
        title: e.msg,
        icon: 'none'
      })
    });
  },
  submitData() {
    let params = {};
    params.data = this.data.formData
    params.data.userType = 3
    params.url = api_user_register;
    net.req(params, true).then((res) => {
      wx.showToast({
        title: res.msg,
        icon: 'none'
      })
      wx.reLaunch({
        url: "/pages/registersuccess/registersuccess?type=3",
      })
    }, (e) => {
      wx.showToast({
        title: e.msg,
        icon: 'none'
      })
    });
  },
  time() {
    let num = 60;
    let timer = setInterval(() => {
      num--;
      this.setData({
        number: num,
        reCode: true
      }, () => {
        if (num === 0) {
          clearInterval(timer);
          this.setData({
            number: 60
          })
        }
      })
    }, 1000);
  },
  // 同意协议
  checkProtocol() {
    this.setData({
      checkProtocol: !this.data.checkProtocol
    })
  },
  // 查看协议
  toProtocol() {
    wx.navigateTo({
      url: `/pages/protocol/protocol`
    })
  }
})