export default class Poster {
    palette(posterArr) {
      if(posterArr && Array.isArray) {
        let canvasObj = {
          views: []
        };
        posterArr.forEach((val, i, arr) => {
          let { elementId, x, y, width, height, dataset } = val;
          let { what, uri } = dataset;
          if (what) {
            what = what.toString();
          }
          switch (elementId) {
            case 'container':
              Object.assign(canvasObj, {
                width: `${width}px`,
                height: `${height}px`,
                background: '#ffffff',
                borderRadius: '0px'
              });
              break;
            case 'above':
              canvasObj.views.push({
                type: 'rect',
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width}px`,
                  height: `${height}px`,
                  color: '#ffffff'
                },
              });
              break;
            case 'imgPhoto':
              canvasObj.views.push({
                type: 'image',
                url: uri || what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width}px`,
                  height: `${height}px`
                }
              });
              break;
            case 'goodsTitle':
              canvasObj.views.push({
                type: 'text',
                text: what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width}px`,
                  fontSize: `32rpx`,
                  color: '#000000',
                  fontWeight: 'bold'
                }
              });
              break;
            case 'goodsAddress':
              canvasObj.views.push({
                type: 'text',
                text: what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width}px`,
                  fontSize: `30rpx`,
                  color: '#000000'
                }
              });
              break;
            case 'moneyNowUnit':
              canvasObj.views.push({
                type: 'text',
                text: what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width}px`,
                  color: '#ff4343',
                  fontSize: `24rpx`
                }
              });
              break;
            case 'moneyNowPrice':
              canvasObj.views.push({
                type: 'text',
                text: what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width + 5}px`,
                  color: '#ff4343',
                  fontSize: `40rpx`,
                  fontWeight: 'bold'
                }
              });
              break;
            case 'moneyOldPrice':
              canvasObj.views.push({
                type: 'text',
                text: what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width + 10}px`,
                  color: '#999999',
                  fontSize: `24rpx`,
                  fontWeight: 'bold',
                  textDecoration: 'line-through',
                }
              });
              break;
            case 'below':
              canvasObj.views.push({
                type: 'rect',
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width}px`,
                  height: `${height}px`,
                  color: 'white'
                }
              });
              break;
            case 'imgLogo':
              canvasObj.views.push({
                type: 'image',
                url: uri || what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width}px`,
                  height: `${height}px`
                }
              });
              break;
            case 'tipsOne':
            case 'tipsTwo':
              canvasObj.views.push({
                type: 'text',
                text: what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width + 10}px`,
                  color: '#000000',
                  fontSize: `24rpx`
                }
              });
              break;
            case 'imgBarcode':
              canvasObj.views.push({
                type: 'image',
                url: uri || what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width}px`,
                  height: `${height}px`
                }
              });
              break;
            case 'imgHead':
              canvasObj.views.push({
                type: 'image',
                url: uri || what,
                css: {
                  left: `${x}px`,
                  top: `${y}px`,
                  width: `${width}px`,
                  height: `${height}px`,
                  borderRadius: `${height}px`
                }
              });
              break;
            default:
              break;
          }
        });
        return canvasObj;
      }
    }
  }
  
  